/*===========================================================================

   FTW Memory ListBox Streamable Buffer header

   $ Version 3.1  10/09/93  22:29:25 $ 

   Copyright 1990, 1993 by Marco Savegnago.  All rights reserved.        
   This software may be freely distributed and used, but it may not        
   under any circumstances be sold by anyone other than the author.        
   It may be distributed by a commercial company as long as it is          
   for no cost.                                                            
                                                                           
===========================================================================*/

#ifndef __LBOXMEM_H
#define __LBOXMEM_H

#include <owldefs.h>
#include <objstrm.h>
#include <listbox.h>


_CLASSDEF(TMemListBoxData)
class TMemListBoxData : public TListBoxData, public TStreamable
{
public:

	TMemListBoxData() : TListBoxData(), TStreamable () {}

    ~TMemListBoxData() {}

  	virtual 	classType isA() const { return __firstUserClass + 1; }
  	virtual 	Pchar nameOf() const { return "TMemListBoxData"; }
  	static 		PTStreamable build();

protected:
  	TMemListBoxData( StreamableInit ) : TListBoxData() {};
  	virtual void 	write( Ropstream );
  	virtual Pvoid 	read( Ripstream );
private:
  	virtual const Pchar streamableName() const
		{ return "TMemListBoxData"; }
};

#endif	// !defined __LBOXMEM_H
